// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cstdio>
#include <ClanLib/clanlayer2.h>

#include "button.hh"

Button::Button(int x, int y, char* str, CL_ResourceManager* resource)
{
  x_pos = x;
  y_pos = y;
  button_p = CL_Res_Surface::load(str, *resource);
  button   = CL_Res_Surface::load(str, *resource);
  font     = CL_Res_Font::load("Fonts/font", *resource);

  if (!button_p || !button) {
    cout << "Button:: \"" << str << "\" not found" << endl;
    exit(EXIT_FAILURE);
  }
}

bool
Button::is_pressed()
{
  return false;
}

void
Button::draw()
{
  font->print_left(x_pos, y_pos, "99");

  if (is_pressed())
    button_p->put_screen(x_pos, y_pos);
  else
    button->put_screen(x_pos, y_pos);
}

void
Button::let_move()
{
  
}

/* EOF */
