// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef COLMAP_HH
#define COLMAP_HH

#include <vector>
#include "point.hh"

enum { air = 0, 
       wall = 255 
};

class ColMap {
private:
  int** colmap;
  int    width;
  int   height;
  bool    init;
  vector<Point> blocker;
  
public:
  ColMap();
  ~ColMap();
  int load(const char* filename);
  int getpixel(int x, int y);
  void set_blocker(int x, int y);
};

#endif

/* EOF */
