// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGU_HH
#define PINGU_HH

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include <string>
#include <vector>
#include "colmap.hh"
#include "pingumap.hh"
#include "int_overflow.hh"

enum Direction { left = -1, right = 1 };
enum Action { bridger=0, exploder, blocker, miner, digger, faller, walker, floater, dead };
enum Action2 {};

// Pingu is the basic object for managing a Pingu. It manage the
// surface the animation and the AI of a pingu, it can also check if
// the pingu is in a given range.

class Pingu
{
private:
  static vector<CL_Surface*> pingu;
  /*  static CL_Surface* explo;
  static CL_Surface* fall_sprite;
  static CL_Surface* walker; */
  static ColMap* colmap;
  static PinguMap* map;

  bool data_loaded;
  Int_Overflow anim_pos;
  bool alive;
  int x_pos, y_pos;
  int falling;
  int direction;
  //string id;
  
  Action  action;
  Action2 action2;

public:
  Pingu();
  Pingu(int x, int y);
  ~Pingu();

  int  rel_getpixel(int x, int y);
  void set_pos(int x, int y);
  void set_action(Action);
  void let_move();
  void get_surface();
  void restore_surface();
  void draw();
  void draw(int x, int y);
  bool is_alive(void);
  bool is_over(int x, int y);
  int  get_x();
  int  get_y();

  // some static variables and functions
  //  static CL_Surface* sprite;
  static void set_colmap(ColMap* a);
  static void set_map(PinguMap*);
  static void load_data(CL_ResourceManager*);
};

#endif

/* EOF */
