// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <stdio.h>

#include "pingu.hh"
#include "mouse.hh"
#include "pingu.hh"
#include "playfield.hh"
#include "plf.hh"

CL_Surface* Playfield::cap;

Playfield::Playfield()
{
  cout << "Playfield:init" << endl;
  current_pingu = 0;
}

Playfield::Playfield(PLF* level_data)
{
  world.init(level_data);
  current_pingu = 0;
  pingu = world.get_pingu_p();
}

Playfield::~Playfield()
{
}

void
Playfield::draw()
{
  // draw the world (Playfield, pingus, ...)
  world.draw();

  // draw the capture rectange
  for (int i=0; i < pingu->size(); ++i) {
    if ((*pingu)[i].is_over(Mouse::get_x(), Mouse::get_y())) {
      cap->put_screen((*pingu)[i].get_x()-17, (*pingu)[i].get_y()-33);
      current_pingu = i;
      break;
    } else {
      current_pingu = -1;
    }
  }
}

void
Playfield::let_move()
{
  world.let_move();

  if (current_pingu != -1 && Mouse::is_pressed(2)) {
    (*pingu)[current_pingu].set_action(buttons->get_action());
  }
}

void
Playfield::load_data(CL_ResourceManager* resource)
{
  cap = CL_Res_Surface::load("Game/cap", *resource);

  if (!cap) {
    cout << "Couldn't load cap" << endl;
    exit(EXIT_FAILURE);
  }
}

void
Playfield::set_buttons(ButtonPanel* b)
{
  buttons = b;
}

/* EOF */
