// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PLF_HH
#define PLF_HH

//#include <string>
//#include <vector>

// PLF stands for PinguLevelFile it gives a easy methode to read the
// informations from *.plf file, it could also provide a transparent
// access to both binary-compressed and text versions of a plf file.

enum plf_token { BG, FG, COL, UNKNOWN, EMPTY, COMMENT, MAPTYPE };
enum MapType { BMP, TILE, UNDEF };

class PLF
{
public:  
  PLF();
  PLF(char*);

  plf_token get_token(char*);
  const char* get_bg();
  const char* get_fg();
  const char* get_name();
  const char* get_pngfile();
  const char* get_mapfile();
  MapType map_type();
  //  vector<string>* get_descr();

private:
  char*    filename;
  char*    fg;
  char*    bg;
  char*    col;
  MapType  maptype;
  //  enum MapType { tiled, bmp } map_type;

  //  string name;
  //  string bgname;
  // vector<string> description;
};

#endif

/* EOF */
