// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef WORLD_HH
#define WORLD_HH

#include <ClanLib/clanlib.h>
#include <vector>

#include "plf.hh"
#include "pingu.hh"
#include "pingutilemap.hh"
#include "background.hh"
#include "colmap.hh"

class World
{
public:
  World();
  ~World();
  void draw();
  void draw_background();
  void draw_pingus();
  void draw_playground();
  void draw_foreground();
  void save();
  void load();
  void load_data(CL_InputSourceProvider*);
  void init(PLF*);
  void let_move();
  vector<Pingu>* get_pingu_p();

  ColMap colmap;
  //  static CL_Surface* gfx_fg;

  static void load_data(CL_ResourceManager*);
  static CL_ResourceManager* resource;
  vector<Pingu> pingu;
  
private:
  PinguMap*  map;
  Background* bg;
  
  CL_Surface* gfx_bg;
  CL_Surface* col_map;
  CL_Surface* gfx_map;

  bool fg_is_drawn;
  bool bg_is_drawn;
  bool pg_is_drawn;
  CL_InputSourceProvider* datafile;
  //  vector<Start_Points>;
  //  vector<End_Points>;
};

#endif

/* EOF */
